<?php


  class netcash {
    var $code, $title, $description, $enabled;

// class constructor
    function netcash() {
      global $order;

      $this->code = 'netcash';
      $this->title = MODULE_PAYMENT_NETCASH_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_PAYMENT_NETCASH_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_NETCASH_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_NETCASH_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_NETCASH_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_NETCASH_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->form_action_url = 'https://gateway.netcash.co.za/vvonline/ccnetcash.asp';
    }

// class methods
    function update_status() {
      global $order, $db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_NETCASH_ZONE > 0) ) {
        $check_flag = false;
        $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_NETCASH_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = zen_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      global $order, $currencies, $currency, $customer_id;
      
      $my_currency = 'ZAR';
     
	
           
      $process_button_string = zen_draw_hidden_field('m_1', MODULE_PAYMENT_NETCASH_USERNAME) .
						zen_draw_hidden_field('m_2', MODULE_PAYMENT_NETCASH_PASSWORD) .
						zen_draw_hidden_field('m_3', MODULE_PAYMENT_NETCASH_PIN) .
						zen_draw_hidden_field('p1', MODULE_PAYMENT_NETCASH_USER_ID) .	
						zen_draw_hidden_field('p2', $_SESSION['customer_id']. '-' . date('Ymdhis')) .
						zen_draw_hidden_field('p3', STORE_NAME) .
						zen_draw_hidden_field('p4', number_format($order->info['total'] * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency),'.','')) .
						zen_draw_hidden_field('m_4', $_SESSION['customer_id'] ) .
						zen_draw_hidden_field('p10', zen_href_link(FILENAME_CHECKOUT_CONFIRMATION, '', 'SSL')) .
						zen_draw_hidden_field('Budget', 'Y').
						zen_draw_hidden_field('m_10', 'main_page=checkout_process');

      return $process_button_string;
    }

    function before_process() {
    global $db;
    
 $TID = $_GET['Extra1'] . '-' . $_GET['CardHolderIpAddr'];
 $appstr = isset($_GET['Reason'])?$_GET['Reason']:'APPROVED';   
$docheck = trim($appstr);

if ($docheck != 'APPROVED'){
zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(PAYMENT_ERROR . $appstr), 'SSL', true, false));
}
      return false;
    }

    function after_process() {
      return false;
    }

    function output_error() {
      return false;
    }

    function check() {
    global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_NETCASH_STATUS'");
        $this->_check = $check_query->RecordCount();;
      }
      return $this->_check;
    }

    function install() { 
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Netcash Username', 'MODULE_PAYMENT_NETCASH_USERNAME', 'Netcash Username', 'This is your Netcash assigned electronic Username', '6', '3', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Netcash Password', 'MODULE_PAYMENT_NETCASH_PASSWORD', '12345', 'This is your Netcash assigned electronic Password', '6', '3', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Netcash electronic PIN', 'MODULE_PAYMENT_NETCASH_PIN', '12345', 'This is your Netcash assigned electronic PIN', '6', '3', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Terminal Number', 'MODULE_PAYMENT_NETCASH_USER_ID', '99999', 'This is your Terminal Number', '6', '3', now())"); 	
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Netcash Module', 'MODULE_PAYMENT_NETCASH_STATUS', 'True', 'Do you want to accept Netcash payments?', '6', '3', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('E-Mail Address', 'MODULE_PAYMENT_NETCASH_ID', 'you@yourbusiness.com', 'The e-mail address to use for the Netcash service', '6', '4', now())");

      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_NETCASH_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_NETCASH_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_NETCASH_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
   
    }

    function remove() {
    global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_NETCASH_STATUS', 'MODULE_PAYMENT_NETCASH_ID', 'MODULE_PAYMENT_NETCASH_USER_ID', 'MODULE_PAYMENT_NETCASH_USERNAME', 'MODULE_PAYMENT_NETCASH_PASSWORD', 'MODULE_PAYMENT_NETCASH_PIN', 'MODULE_PAYMENT_NETCASH_ORDER_STATUS_ID', 'MODULE_PAYMENT_NETCASH_ZONE', 'MODULE_PAYMENT_NETCASH_SORT_ORDER');
    }
  }
?>
